/********************************************************************
RFM01-Funkmodul (Empfangen)
*********************************************************************/

#include <avr/io.h>
#include <util/delay.h>
#include "rfm01.h"
#include "uart.h"

void view_byte(uint8_t byte)
{
	unsigned wait = 500;
	for (int bit=0;bit<8;bit++)
	{
		LED_ON();
		if ((byte & 0b00000001)==0) BLED_OFF();
		else BLED_ON();
		_delay_ms(wait);
		LED_OFF();
		_delay_ms(wait);
		byte = byte>>1;
	}
	BLED_OFF();
}

void gpio_init()
{
	// Initialize On-Board LED on PB5
	LED_OFF();
	DDR_LED |= (1<<LED);

	BLED_OFF();
	DDR_BLED |= (1<<BLED);
}

void heartbeat()
{
	uint8_t wait = 100;
	//LED_ON();
	BLED_ON();
	_delay_ms(wait);
	//LED_OFF();
	BLED_OFF();
	_delay_ms(wait);
	//LED_ON();
	BLED_ON();
	_delay_ms(wait);
	//LED_OFF();
	BLED_OFF();
	_delay_ms(wait);
}

char check_paket(char *, char);

int main(void)
{
	char data_buf[10];
	char paket_len = 10;
	unsigned int status = 0;

  uart_init();
  uart_send_text("Reset RX\r\n");
  gpio_init();
  uart_send_text("gpio-Init ok\r\n");
  rfm01_init();
  uart_send_text("rfm02_init ok\r\n");

	//status = rfm01_read_status();
	
	heartbeat();
	_delay_ms(500);
	
	while (1)
	{
		_delay_ms(100);
		LED_ON();
		//view_byte(rfm01_read_fifo(data_buf, paket_len));
		rfm01_read_fifo(data_buf, paket_len);
		
		char i;
    uart_send_newline();
		for (i=0; i< paket_len; i++)
      {
        uart_send_byte_hex(data_buf[i]);
        uart_send_byte(' ');
      }
    uart_send_newline();       

		if (check_paket(data_buf, paket_len))
		{
			BLED_ON();
		}
		
		LED_OFF();
		

		//rfm01_read_status();
		
		//_delay_ms(100);
		//heartbeat();
		
	}
}

char check_paket(char *data_buf, char len)
{
	char myByte = 0b10101010;
	char myByte2 = 0b11001100;
	unsigned char i, flag=0;

	for (i=0; i<len; i++)
	{
		
		if(data_buf[i] == myByte) flag = 1;
		//if(data_buf[i] == myByte2) flag = 1;
		
		/*
		if(data_buf[i] == 0xA) flag = 1;
		if(data_buf[i] == 0x2D) flag = 1;
		if(data_buf[i] == 0xD4) flag = 1;
		if(data_buf[i] == 0b11111111) flag = 1;
		*/
		if(data_buf[i] != 0) flag = 1;
	}

	return flag;
}
