/********************************************************************
RFM01-Funkmodul (Empfangen)

-----------------------
ATMEGA168PA       RFM01
-----------------------
PD2...............SDI
PD3...............SDO
PD4...............SCK
PD5...............nSEL
PD6...............nFFS
*********************************************************************/
#include "avr/io.h"
#include "util/delay.h"

#define DDR_BLED DDRC
#define BLED 0
#define DDR_LED DDRB
#define LED 5

#define LED_ON() PORTB |= (1<<LED)
#define LED_OFF() PORTB &= ~(1<<LED)
#define BLED_ON() PORTC |= (1<<BLED)
#define BLED_OFF() PORTC &= ~(1<<BLED)

#define RFM01_PORT PORTD
#define RFM01_DDR DDRD
#define RFM01_PIN PIND
#define RFM01_SDI 2
#define RFM01_SDO 3
#define RFM01_SCK 4
#define RFM01_nSEL 5
#define RFM01_nFFS 6

#define SDI_HIGH() RFM01_PORT |= (1<<RFM01_SDI)
#define SDI_LOW() RFM01_PORT &= ~(1<<RFM01_SDI)
#define SDO_isHIGH() RFM01_PIN & (1<<RFM01_SDO)
#define SDO_isLOW() !(RFM01_PIN & (1<<RFM01_SDO))
#define SCK_HIGH() RFM01_PORT |= (1<<RFM01_SCK)
#define SCK_LOW() RFM01_PORT &= ~(1<<RFM01_SCK)
#define nSEL_HIGH() RFM01_PORT |= (1<<RFM01_nSEL)
#define nSEL_LOW() RFM01_PORT &= ~(1<<RFM01_nSEL)
#define nFFS_HIGH() RFM01_PORT |= (1<<RFM01_nFFS)
#define nFFS_LOW() RFM01_PORT &= ~(1<<RFM01_nFFS)

// nFFS: 1-10k Pullup an Vcc !!!

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////// FUNCTIONS /////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef __cplusplus
extern "C" {
#endif

void rfm01_init();

void rfm01_send_cmd(unsigned int command);
unsigned char rfm01_read_fifo(char *data_buf, char len);
unsigned int rfm01_read_status();

#ifdef __cplusplus
}
#endif

