
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include "UART.h"

void uart_init(void)
{

	UBRR0H = (UBRR_VAL >> 8);
	UBRR0L = UBRR_VAL & 0xFF;
	UCSR0B =	(1<<TXEN0);
	UCSR0C =	(1<<UCSZ01) | (1<<UCSZ00);
}

void uart_send_byte(char zeichen)
{
	while (!(UCSR0A & (1<<UDRE0)))				// warten bis UDER 1
	 	{
		}
	UDR0 = zeichen;
}

void uart_send_text_p(const char *text)
{
    char zeichen;

    while ((zeichen = pgm_read_byte(text)))
    {
        uart_send_byte(zeichen);
        text++;
    }
}

void uart_send_text(const char *text)
{
    char zeichen;

    while ((zeichen = *text))
    {
        uart_send_byte(zeichen);
        text++;
    }
}

void uart_send_newline(void)
{
  uart_send_byte('\r');
  uart_send_byte('\n');
}

void uart_send_byte_hex(char byte)
{
	char zeichen;
	zeichen = '0' | ((byte & 0xF0) >> 4);
	if (zeichen > '9')
	  {
	    zeichen += 7;
	  }
	uart_send_byte(zeichen);

	zeichen = '0' | (byte & 0x0F);
	if (zeichen > '9')
	  {
	    zeichen += 7;
	  }
	uart_send_byte(zeichen);
}

void uart_send_byte_bin(char byte)
{
  char i;
  for (i=0; i<8; i++)
    {
      if (byte & 0b10000000)
        {         
          uart_send_byte('1');
        }
      else
        {         
          uart_send_byte('0');
        }
      byte = byte << 1;         
    }
}
