
#define UART_BAUD_RATE	38400

#define UBRR_VAL ((F_CPU+UART_BAUD_RATE*8)/(UART_BAUD_RATE*16)-1)   // clever runden
#define BAUD_REAL (F_CPU/(16*(UBRR_VAL+1)))     					// Reale Baudrate
#define BAUD_ERROR ((BAUD_REAL*1000)/UART_BAUD_RATE) 				// Fehler in Promille, 1000 = kein Fehler.
 
#if ((BAUD_ERROR<990) || (BAUD_ERROR>1010))
  #error Systematischer Fehler der Baudrate gr�sser 1% und damit zu hoch! 
#endif

#ifdef __cplusplus
extern "C" {
#endif

void uart_init(void);		// initialisiert den UART
void uart_send_byte(char zeichen);
void uart_send_text_p(const char *text);
void uart_send_text(const char *text);
void uart_send_byte_hex(char byte);
void uart_send_byte_bin(char byte);
void uart_send_newline(void);

#ifdef __cplusplus
}
#endif

