/********************************************************************
RFM02-Funkmodul (Senden)

-----------------------
ATMEGA168PA       RFM02
-----------------------
PD2...............SDI
PD3...............nIRQ (SDO)
PD4...............SCK
PD5...............nSEL
*********************************************************************/
#include "avr/io.h"

#define RFM02_PORT PORTD
#define RFM02_DDR DDRD
#define RFM02_PIN PIND
#define RFM02_SDI 2
#define RFM02_nIRQ 3
#define RFM02_SCK 4
#define RFM02_nSEL 5

#define SDI_HIGH() RFM02_PORT |= (1<<RFM02_SDI)
#define SDI_LOW() RFM02_PORT &= ~(1<<RFM02_SDI)
#define nIRQ_isHIGH() RFM02_PIN&(1<<RFM02_nIRQ)
#define nIRQ_isLOW() !(RFM02_PIN&(1<<RFM02_nIRQ))
#define SCK_HIGH()  RFM02_PORT |= (1<<RFM02_SCK)
#define SCK_LOW() RFM02_PORT &= ~(1<<RFM02_SCK)
#define nSEL_HIGH() RFM02_PORT |= (1<<RFM02_nSEL)
#define nSEL_LOW() RFM02_PORT &= ~(1<<RFM02_nSEL)

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////// FUNCTIONS /////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef __cplusplus
extern "C" {
#endif

void rfm02_init();

uint8_t rfm02_send_cmd();
uint8_t rfm02_send_8bit(uint8_t);
void rfm02_send_data(uint8_t);

void rfm02_transmit_data(uint8_t data[]);

#ifdef __cplusplus
}
#endif

